unit U_Onde;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, mmsystem, BlocBtn, Spin;

type
  TOndes = class(TForm)
    Panel1: TPanel;
    Sin1: TTrackBar;
    Sin2: TTrackBar;
    Sin3: TTrackBar;
    Sin4: TTrackBar;
    Sin5: TTrackBar;
    Sin6: TTrackBar;
    Cos1: TTrackBar;
    Cos2: TTrackBar;
    Cos3: TTrackBar;
    Cos4: TTrackBar;
    Cos5: TTrackBar;
    Cos6: TTrackBar;
    label0: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Sin7: TTrackBar;
    Sin8: TTrackBar;
    Label14: TLabel;
    Label15: TLabel;
    Cos7: TTrackBar;
    Cos8: TTrackBar;
    Label16: TLabel;
    Label17: TLabel;
    cbEntendre: TCheckBox;
    bbSauve: TBlocBtn;
    Label18: TLabel;
    bbRestore: TBlocBtn;
    Label19: TLabel;
    Freq: TSpinEdit;
    Label20: TLabel;
    procedure AmplitudeChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure cbEntendreClick(Sender: TObject);
    procedure Paint; override;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure bbRestoreClick(Sender: TObject);
    procedure bbSauveClick(Sender: TObject);
    procedure FreqChange(Sender: TObject);
  private { Dclarations prives }
  public  { Dclarations publiques }
  end;

var
  Ondes: TOndes;

implementation

{$R *.DFM}

Const
  PotMax=8;

Type
  TPots=array[1..PotMax] of Double;

  TMemoPots=Record
    Used:Boolean;
    Sin:TPots;
    Cos:TPots;
    F  :Integer;
  End;

Var
  PotsSin : TPots;
  PotsCos : TPots;

  Memos:Array[0..9] of TMemoPots;
  Restore:Boolean;

//------------------------------------------------------------------------------
// Gestion de l'onde  jouer
//------------------------------------------------------------------------------

type
  TBuf4=Array[0..3] of Char;

  { format of WAV file header }
  PWavHeader = ^TWavHeader;
  TWavHeader = record          // parameter description
    rId             : TBuf4;   // 'RIFF'  4 characters
    rLen            : longint; // length of DATA + FORMAT chunk
    { FORMAT CHUNK }
    wId             : TBuf4;   // 'WAVE'
    fId             : TBuf4;   // 'fmt '
    fLen            : longint; // length of FORMAT DATA = 16
    { format data }
    wFormatTag      : word;    // $01 = PCM
    nChannels       : word;    // 1 = mono, 2 = stereo
    nSamplesPerSec  : longint; // Sample frequency ie 11025
    nAvgBytesPerSec : longint; // = nChannels * nSamplesPerSec * (nBitsPerSample/8)
    nBlockAlign     : word;    // = nChannels * (nBitsPerSAmple / 8
    wBitsPerSample  : word;    // 8 or 16

    { DATA CHUNK }
    dId             : TBuf4;   { 'data' }
    wSampleLength   : longint; { length of SAMPLE DATA }
    { sample data : offset = 44 }
    { 8 bit mono    : s[0],s[1]... :byte}
    { 16 bit mono   : s[0],s[1]... :word}
    { 8 bit stereo  : sleft[0],sright[0],sleft[1],sright[1]... :byte}
    { 16 bit stereo : sleft[0],sright[0],sleft[1],sright[1]... :word}
  end;

Const
  Resolution = 16;      //16 bits par chantillon
  Channels   = 1;       //Mono
  Rate       = 44100;   //Frquence d'chantillonage
  BufLen     = 4410;    //Longueur du buffer = 0.1 s

  BytesPerSample = 2;
  MaxVal = 32767;
  MinVal = -32767;

var
  DataSize:Integer;
  WaveBuf:Pointer;
  Playing:Boolean; //Son en cours
  Fondam:Integer;  //Frquence fondamentale gnre

Procedure JoueSon;
Var
  I,J:Integer;
  P:PWord;
  t,Ampl:Double;
Begin
  //Recalcule la table des chantillons.
  P:=Pointer(PChar(WaveBuf)+SizeOf(TWavHeader));
  For I:=0 to BufLen-1 do
  Begin
    t:=2*PI*Fondam/Rate * I{/BufLen};
    Ampl:=0;
    For J:=1 to PotMax do
      Ampl:=Ampl+ (PotsSin[J]*Sin(t*J) + PotsCos[J]*cos(t*J)) *32767/PotMax;
    P^:=Round(Ampl);
    Inc(P);
  End;
  If Not playing then
    Playing:=PlaySound(WaveBuf, 0, SND_ASYNC or SND_LOOP or SND_MEMORY);
End;


procedure TOndes.cbEntendreClick(Sender: TObject);
begin
  If cbEntendre.Checked then
    JoueSon
  else
  Begin
    PlaySound(nil, 0, 0);   //stoppe le son
    Playing:=False;
  End;
end;

//------------------------------------------------------------------------------
// Cration, Destruction
//------------------------------------------------------------------------------

procedure TOndes.FormCreate(Sender: TObject);
Var I:Integer;
begin
  Playing:=False;
  Restore:=False;

  DataSize:=2{bytes per sample}*BufLen{Dure=1s};

  //Init buffer son
  GetMem(WaveBuf,DataSize+SizeOf(TWavHeader)+4);
  With PWavHeader(WaveBuf)^ do
  Begin
    rId             := 'RIFF';
    rLen            := DataSize+36; //length of sample + format
    wId             := 'WAVE';
    fId             := 'fmt ';
    fLen            := 16;        // length of format chunk
    wFormatTag      := 1;         // PCM data
    nChannels       := channels;
    nSamplesPerSec  := rate;
    nAvgBytesPerSec := channels*rate*(resolution div 8);
    nBlockAlign     := channels*(resolution div 8);
    wBitsPerSample  := resolution;
    dId             := 'data';
    wSampleLength   := DataSize;  // sample size
  End;

  //Lit tous les potentiomtres
  for I:=1 to PotMax do
  begin
    PotsSin[I]:=(100-(FindComponent('Sin'+char(I+48)) as TTrackBar).Position)/50 ;
    PotsCos[I]:=(100-(FindComponent('Cos'+char(I+48)) as TTrackBar).Position)/50 ;
  end;
  Fondam := 440; // "La" par dfaut
end;

procedure TOndes.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  If Playing then
    PlaySound(Nil,0,0); //Stoppe
  FreeMem(WaveBuf);
  CanClose:=True;
end;


//------------------------------------------------------------------------------
// Gestion de l'cran
//------------------------------------------------------------------------------

procedure TOndes.Paint;
var
  W2,H2: Integer;
  I,J  : Integer;
  X,Y  : Double;
begin
  W2:=(ClientWidth-Panel1.Width) div 2;
  H2:=ClientHeight div 2;
  with Canvas do
  begin
    Pen.Color:=clRed;
    moveto(0, H2); Lineto(ClientWidth, H2);
    moveto(W2, 0); LineTo(W2, Height);

    Pen.Color:=clBlack;
    X:=-2*PI;
    Y:=H2;
    for J:=1 to PotMax do
      Y:=Y+(PotsSin[J]*Sin(X*J)+PotsCos[J]*cos(X*J))*H2/PotMax;
    MoveTo(0, Round(Y));

    for I:=0 to clientWidth-Panel1.Width do
    begin
      X:=(I-W2)*2*PI/W2; // de -2PI  +2PI
      Y:=H2;
      for J:=1 to PotMax do
        Y:=Y+(PotsSin[J]*Sin(X*J)+PotsCos[J]*cos(X*J))*H2/PotMax;
      LineTo(I, Round(Y));
    end;
  end;
end;

procedure TOndes.AmplitudeChange(Sender: TObject);
Var I:Integer;
  TB:TTrackBar absolute Sender;
begin
  If restore then Exit;
  
  I:=TB.Tag;
  If I<=8
    then PotsSin[I]  :=(100-TB.Position)/50
    else PotsCos[I-8]:=(100-TB.Position)/50;
  Repaint;
  If Playing then
    JoueSon;
end;

procedure TOndes.FormResize(Sender: TObject);
begin
  RePaint;
end;

procedure TOndes.bbSauveClick(Sender: TObject);
Var
  BB:TBlocBtn absolute Sender;
begin
  With Memos[BB.BtnIndex] do
  Begin
    Used:=BB.Btn[BB.BtnIndex].Down;
    If Used then
    Begin
      Sin:=PotsSin;
      Cos:=PotsCos;
      F  :=Fondam;
      Used:=True;
    End;
  End;
end;

procedure TOndes.bbRestoreClick(Sender: TObject);
Var
  BB:TBlocBtn absolute Sender;
begin
  With Memos[BB.BtnIndex] do
    If Used then
    Begin
      Restore:=True;
      PotsSin:=Sin;
      PotsCos:=Cos;
      Sin1.Position:=100-Round(Sin[1]*50);
      Sin2.Position:=100-Round(Sin[2]*50);
      Sin3.Position:=100-Round(Sin[3]*50);
      Sin4.Position:=100-Round(Sin[4]*50);
      Sin5.Position:=100-Round(Sin[5]*50);
      Sin6.Position:=100-Round(Sin[6]*50);
      Sin7.Position:=100-Round(Sin[7]*50);
      Sin8.Position:=100-Round(Sin[8]*50);

      Cos1.Position:=100-Round(Cos[1]*50);
      Cos2.Position:=100-Round(Cos[2]*50);
      Cos3.Position:=100-Round(Cos[3]*50);
      Cos4.Position:=100-Round(Cos[4]*50);
      Cos5.Position:=100-Round(Cos[5]*50);
      Cos6.Position:=100-Round(Cos[6]*50);
      Cos7.Position:=100-Round(Cos[7]*50);
      Cos8.Position:=100-Round(Cos[8]*50);
      Fondam:=F;
      Freq.Value:=F;

      Restore:=False;
      Repaint;
      If Playing then
        JoueSon;
    End;
end;

procedure TOndes.FreqChange(Sender: TObject);
begin
  Fondam:=Freq.Value;
  If Playing then
    JoueSon;
end;

end.
